import { Meta, Canvas, Story } from '@storybook/addon-docs'
import { Template } from './MSourceVector.stories.js'

<Meta title="Sources/Readme" />

# Sources

Sources provide data for layers to display.
They are required parent components for the layers,
dedicated to rendering the data in the DOM.

For exemple, `<m-source-geojson>` holds the geojson data and `<m-layer-line>`
draw the line on the map.

```
<m-source-geojson>
  <m-layer-line />
</m-source-geojson>
```

`<m-source-geojson>`<br />
To manage geojson data and clusters<br />
`import { MSourceGeojson } from '@atlastories.app/vue-maplibre'`

`<m-source-image>`<br />
To add an image to the map<br />
`import { MSourceImage } from '@atlastories.app/vue-maplibre'`

`<m-source-raster>`<br />
To add raster tiles to the map<br />
`import { MSourceRaster } from '@atlastories.app/vue-maplibre'`

`<m-source-raster-dem>`<br />
To add elevation data to the map<br />
`import { MSourceRasterDem } from '@atlastories.app/vue-maplibre'`

`<m-source-vector>`<br />
To add vector data to the map<br />
`import { MSourceVector } from '@atlastories.app/vue-maplibre'`

`<m-source-video>`<br />
To add a video to the map<br />
`import { MSourceImage } from '@atlastories.app/vue-maplibre'`

## Events

Sources are not meant to render elements, they have no event to observe.

## Parents for layers

`<m-source-geojson>` and `<m-source-vector>` require some layers to display their data.

<Canvas>
  <Story
    name="Example"
    args={{
      url: 'https://api.maptiler.com/tiles/contours/tiles.json?key=get_your_own_OpIi9ZULNHzrESv6T2vL'
    }}>
    {Template.bind({})}
   </Story>
</Canvas>

```
<m-source-vector
  url="https://api.maptiler.com/tiles/contours/tiles.json?key=get_your_own_OpIi9ZULNHzrESv6T2vL">

  <m-layer-line
    sourceLayer="contour"
    color="#ff69b4" />

</m-source-vector>
```
Follow [the url of the source vector](https://api.maptiler.com/tiles/contours/tiles.json?key=get_your_own_OpIi9ZULNHzrESv6T2vL),
the `vector_layer` property is an array of available vector layers.
The id of the layer is the value required for the child property `sourceLayer`.

`sourceLayer` is a required property for the children of `<m-source-vector>`

# Sources filled with layers

`image`, `video`, `raster` and `rasterDem` sources are filled by default with layers,
for example: `<m-source-raster-dem>` will internally render a `<m-layer-hillshade>`
component in it's default slot.

```
<m-source-raster-dem
  url="/tiles.json"
  :tileSize="256">
  <!-- <m-layer-hillshade> already 'inside' -->
</m-source-raster-dem>
```

<Canvas>
  <Story id="sources-msourcerasterdem--source" />
</Canvas>

If you want to change the default layer, or add some event observers,
you can fill in the default slot of the source component.

```
<m-source-raster-dem
  url="/tiles.json"
  :tileSize="256">

  <m-layer-hillshade
    color="orange"
    :exaggeration="0.2" />

</m-source-raster-dem>
```

<Canvas>
  <Story id="layers-mlayerhillshade--color" />
</Canvas>

## Cluster

`<m-source-geojson>` has properties to handle clusters of points.
The following example requires 3 childs:

```
<m-source-geojson
  cluster
  data="https://atlastories.gitlab.io/vue-maplibre/earthquakes.geojson">

  <!-- Cluster circles -->
  <m-layer-circle
    :filter="['has', 'point_count']" />

  <!-- Cluster count -->
  <m-layer-symbol
    :filter="['has', 'point_count']">
    <m-layer-symbol-text
      field="{point_count_abbreviated}" />
  </m-layer-symbol>

  <!-- Unclustered points -->
  <m-layer-circle
    :filter="['!', ['has', 'point_count']]" />

</m-source-geojson>
```

<Canvas>
  <Story id="sources-msourcegeojson--cluster" />
</Canvas>
